#----------------------------MReader License--------------------------------
"""
MReader v0.1 Beta
Copyright (c) 2013, Suryansh Pradhan
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."""

#----------------------------EasyGUI License--------------------------------

"""EasyGui version 0.96

Copyright (c) 2010, Stephen Raymond Ferg

All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer. 
    
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation and/or
       other materials provided with the distribution. 
    
    3. The name of the author may not be used to endorse or promote products derived
       from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."""

#!/usr/bin/python
# coding=utf-8
# -*- coding: utf-8 -*-
template="""<html><title>:::TITLE:::</title><body>:::BODY:::<p>Images courtesy of <a href="http://www.mangaeden.com/"><em>MangaEden.</em></a> Page created by MReader (c) 2013 <a href="http://suryanshpradhan.wordpress.com"><i>Suryansh Pradhan</i></a></body></html>"""
from easygui import *
import json,urllib,sys
try:
 mList=json.loads(urllib.urlopen("http://www.mangaeden.com/api/list/0/").read())['manga']
except:
      msgbox("Sorry, either you don't have an internet connection or something is wrong with your installation. Please try again or contact the author at suryanshpradhan.wordpress.com","Error")
      sys.exit()
#mList=json.loads(open("mangalist.txt").read())['manga']
results={}
dict1={}
searchTerm=enterbox("MReader v0.1 (Beta)\n(c) Suryansh Pradhan\nEnter search terms","Search MangaEden's database","")
for i in mList:
     if searchTerm.lower() in i['t'].lower():
          results[i['t']]=i
if len(results)==0:
     msgbox("Sorry, no results found.","Oops")
else:
     selectedManga=choicebox(str(len(tuple(results)))+" result(s) found.\n Select the one you would like to read.","Select",tuple(results))
     selected=results[selectedManga]; print "id is",selected['i']
     moreInfo=json.loads(urllib.urlopen("http://www.mangaeden.com/api/manga/"+selected['i']).read())
     for i in moreInfo['chapters']:
      #print type(i),"---------",len(i),"---------",i[0],"---------",i[3]
      if i[0]<10: numCorrect="Chapter #00"+str(i[0])
      if i[0]>=10 and i[0]<100: numCorrect="Chapter #0"+str(i[0])
      if i[0]>=100: numCorrect="Chapter #"+str(i[0])
      dict1[numCorrect]=i[3]
     print dict1
     selectCh=multchoicebox("Select Chapter","Select Chapter",tuple(dict1))
     print selectCh
     for i in selectCh:
      chapter_id=dict1[i]
      chapterInfo=json.loads(urllib.urlopen("http://www.mangaeden.com/api/chapter/"+chapter_id+"/").read())
      print selected
      image_dict={}
      for j in chapterInfo['images']:
       image_dict[j[0]]="http://cdn.mangaeden.com/mangasimg/"+str(j[1])
      html=""
      for k in image_dict:
       html+="<p>Page "+str(k)+"<img src="+image_dict[k]+"><hr /></p>"
      print html,selectedManga,i
      generate_html=open(selectedManga+" - "+i+".html","w")
      generate_html.write(template.replace(":::BODY:::",html).replace(":::TITLE:::",selectedManga+" - "+i))
      generate_html.close()
      msgbox(selectedManga+" - "+i+".html has been created. Open the file to read "+i+" of "+selectedManga+".")
if len(results)!=0:
     msgbox("And now a message from the shameless author : \n'Liked MReader? Hated MReader? Leave your feedback at suryanshpradhan.wordpress.com/code/mreader\nThanks!'")
